<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__flash" kind="group">
    <compoundname>group_hal_flash</compoundname>
    <title>Flash (Flash System Routine)</title>
    <innerclass prot="public" refid="structcyhal__flash__block__info__t">cyhal_flash_block_info_t</innerclass>
    <innerclass prot="public" refid="structcyhal__flash__info__t">cyhal_flash_info_t</innerclass>
    <innergroup refid="group__group__hal__results__flash">Flash HAL Results</innergroup>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga669e3789204d0cf9610a85f26a28c55b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_init</definition>
        <argsstring>(cyhal_flash_t *obj)</argsstring>
        <name>cyhal_flash_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Initialize the <ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> object for accessing flash through the HAL. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a flash object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="141" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga27db9641684bfa6d0b64088448b8e050" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_flash_free</definition>
        <argsstring>(cyhal_flash_t *obj)</argsstring>
        <name>cyhal_flash_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Free resources associated with flash object through the HAL. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="148" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_flash_get_info</definition>
        <argsstring>(const cyhal_flash_t *obj, cyhal_flash_info_t *info)</argsstring>
        <name>cyhal_flash_get_info</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__info__t">cyhal_flash_info_t</ref> *</type>
          <declname>info</declname>
        </param>
        <briefdescription>
<para>Gets flash characteristics like the start address, size, erase values etc. </para>        </briefdescription>
        <detaileddescription>
<para>Refer <ref kindref="compound" refid="structcyhal__flash__info__t">cyhal_flash_info_t</ref> for more information.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">info</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash characteristic info.</para></parameterdescription>
</parameteritem>
</parameterlist>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_1">Snippet 1: Discovering flash characteristics</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="158" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1gab21b7e9300c5b630e9656f71decedaf8" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_read</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address, uint8_t *data, size_t size)</argsstring>
        <name>cyhal_flash_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>size</declname>
        </param>
        <briefdescription>
<para>Read data starting at a defined address. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>Address to begin reading from. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The buffer to read data into. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">size</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of bytes to read. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation.</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_2">Snippet 2: Blocking Flash Write Operation</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="171" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga10b68f24a5c9a7c929a2c1fa3af89858" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_erase</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address)</argsstring>
        <name>cyhal_flash_erase</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <briefdescription>
<para>Erase one page starting at a defined address. </para>        </briefdescription>
        <detaileddescription>
<para>The address must be at page boundary. This will block until the erase operation is complete.</para><para><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the page erase size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The page starting address </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the erase request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation.</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_2">Snippet 2: Blocking Flash Write Operation</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="185" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga622b0c7a66fb46946eedea821b5e12aa" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_write</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address, const uint32_t *data)</argsstring>
        <name>cyhal_flash_write</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>const uint32_t *</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>This function erases the page and writes the new data into the page starting at a defined address. </para>        </briefdescription>
        <detaileddescription>
<para>The address must be at page boundary. This will block until the write operation is complete.</para><para><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the page write size. The provided data buffer must be at least as large as the flash page_size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The page starting address </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data to write to the flash </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the write request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation.</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_2">Snippet 2: Blocking Flash Write Operation</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="202" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga66a23d2dfbe01d027f8e9318999b7e19" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_program</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address, const uint32_t *data)</argsstring>
        <name>cyhal_flash_program</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>const uint32_t *</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>Program one page with given data starting at defined address. </para>        </briefdescription>
        <detaileddescription>
<para>The address must be at page boundary. This will block until the write operation is complete. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This function does not erase the page prior to writing. The page must be erased first via a separate call to erase.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the total page size. The provided data buffer must be at least as large as the flash page_size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The flash object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The sector starting address </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data buffer to be programmed </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the program request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="218" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga90697ece402e7e5f02303dbe568d0ba3" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_start_erase</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address)</argsstring>
        <name>cyhal_flash_start_erase</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <briefdescription>
<para>Starts an asynchronous erase of a single page of flash. </para>        </briefdescription>
        <detaileddescription>
<para>Returns immediately and reports a successful start or reason for failure. The address must be aligned on a page boundary.</para><para><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the page erase size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The Flash object being operated on </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The address to start erasing from </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start_erase request.</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_3">Snippet 3: Non-blocking Flash Write Operation using polling</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="232" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga7de934ab80e8fcb82554735c98da3665" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_start_write</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address, const uint32_t *data)</argsstring>
        <name>cyhal_flash_start_write</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>const uint32_t *</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>Starts an asynchronous write to a single page of flash. </para>        </briefdescription>
        <detaileddescription>
<para>Returns immediately and reports a successful start or reason for failure. The address must be aligned on a page boundary.</para><para><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the page write size. The provided data buffer must be at least as large as the flash page_size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The Flash object being operated on </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The address to start writing to </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data to write to flash </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start_write request.</para></simplesect>
Refer <ref kindref="member" refid="group__group__hal__flash_1subsection_flash_use_case_3">Snippet 3: Non-blocking Flash Write Operation using polling</ref> for more information. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="248" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1ga1e2ea114a8c7be82e928938e962adce1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_flash_start_program</definition>
        <argsstring>(cyhal_flash_t *obj, uint32_t address, const uint32_t *data)</argsstring>
        <name>cyhal_flash_start_program</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>address</declname>
        </param>
        <param>
          <type>const uint32_t *</type>
          <declname>data</declname>
        </param>
        <briefdescription>
<para>Starts asynchronous programming of a single page of flash. </para>        </briefdescription>
        <detaileddescription>
<para>Returns immediately and reports a successful start or reason for failure.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Perform erase operation prior to calling this.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><simplesect kind="see"><para><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info()</ref> to get the flash characteristics for legal address values and the total page size. The provided data buffer must be at least as large as the flash page_size.</para></simplesect>
<parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The Flash object being operated on </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>The address to start programming </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">data</parametername>
</parameternamelist>
<parameterdescription>
<para>The data to write to flash </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the start_program request. Returns <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> on successful operation. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="264" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__flash_1gad3f9a6b2b2af077d862c98bb7aa624ac" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_flash_is_operation_complete</definition>
        <argsstring>(cyhal_flash_t *obj)</argsstring>
        <name>cyhal_flash_is_operation_complete</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Reports status of the flash operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The Flash object being operated on </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>true if flash operation is complete. false otherwise. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_flash.h" line="271" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface to the internal flash memory. </para>    </briefdescription>
    <detaileddescription>
<para>Flash memory provides non-volatile storage for user firmware, user configuration data, and bulk data storage.</para><para>This driver allows data to be read from and written to flash. It also provides the ability to obtain information about the address and characteristics of the flash block(s) contained on the device. During flash write time, the device should not be reset (including XRES pin, software reset, and watchdog) or unexpected changes may be made to portions of the flash. Also, the low-voltage detect circuits should be configured to generate an interrupt instead of a reset.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;A Read while Write violation may occur for some devices when a flash Read operation is initiated in the same or neighboring flash sector where the flash Write, Erase, or Program operation is working. Refer the the device datasheet for more information. This violation may cause a HardFault exception. To avoid the Read while Write violation, the user must carefully split the Read and Write operations on flash sectors which are not neighboring, considering all cores in a multi-processor device. You may edit the linker script to place the code into neighboring sectors. For example, use sectors number 0 and 1 for code and sectors 2 and 3 for data storage.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>Flash operations are performed on a per-sector basis</para></listitem><listitem><para>Supports blocking or partially blocking erase, program and write </para></listitem></itemizedlist>
</para>

<para><heading level="1">Code Snippets</heading></para>

<para><bold>Snippet 1: Discovering flash characteristics</bold></para>
<para>Following code snippet demonstrates how to discover flash characteristics. Refer <ref kindref="compound" refid="structcyhal__flash__info__t">cyhal_flash_info_t</ref> for more information. <programlisting filename="flash.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref><sp />flash_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__flash__info__t">cyhal_flash_info_t</ref><sp />flash_info;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />flash_start_address;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />flash_size;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />flash_sector_size;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />flash_page_size;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />flash_erase_value;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />flash<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__flash_1ga669e3789204d0cf9610a85f26a28c55b">cyhal_flash_init</ref>(&amp;flash_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Get<sp />flash<sp />characteristics<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__flash_1gaab923541b1d1f71b0b9545306a9c559a">cyhal_flash_get_info</ref>(&amp;flash_obj,<sp />&amp;flash_info);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />100ms<sp />for<sp />the<sp />flash<sp />write<sp />to<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />timeout<sp />=<sp />100;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />the<sp />command<sp />to<sp />finish<sp />execution<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">((</highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />!=<sp /><ref kindref="member" refid="group__group__hal__flash_1gad3f9a6b2b2af077d862c98bb7aa624ac">cyhal_flash_is_operation_complete</ref>(&amp;flash_obj))<sp />&amp;&amp;<sp />(0<sp />&lt;<sp />timeout))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />timeout--;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga5f450769c1207d98134a9ced39adfdda">cyhal_system_delay_ms</ref>(1);<sp /></highlight><highlight class="comment">/*<sp />delay<sp />one<sp />millisecond<sp />each<sp />iteration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0<sp />!=<sp />timeout)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />index<sp />=<sp />0;<sp />index<sp />&lt;<sp />flash_info.<ref kindref="member" refid="structcyhal__flash__info__t_1a4084c53e5f07ca60c8fb3bcbb2af11a4">block_count</ref>;<sp />index++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__flash__block__info__t">cyhal_flash_block_info_t</ref><sp />*block_info<sp />=<sp />flash_info.<ref kindref="member" refid="structcyhal__flash__info__t_1abf8824c2c183140e0904dec90cffe877">blocks</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />block_info<sp />+=<sp />index;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />flash_start_address<sp />=<sp />block_info-&gt;<ref kindref="member" refid="structcyhal__flash__block__info__t_1a7066dc8bfd2f85ba0a0a8fa61afe9a9d">start_address</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />flash_size<sp />=<sp />block_info-&gt;<ref kindref="member" refid="structcyhal__flash__block__info__t_1a28cdf0683abfa135ae3711631cb137a7">size</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />flash_sector_size<sp />=<sp />block_info-&gt;<ref kindref="member" refid="structcyhal__flash__block__info__t_1ab007e1eb95459c533ed133bb982eaac5">sector_size</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />flash_page_size<sp />=<sp />block_info-&gt;<ref kindref="member" refid="structcyhal__flash__block__info__t_1a50f22883955ce253d7910ca94dcd654d">page_size</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />flash_erase_value<sp />=<sp />block_info-&gt;<ref kindref="member" refid="structcyhal__flash__block__info__t_1a736a77cdecefcca007609dd7b73b9996">erase_value</ref>;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Blocking Flash Write Operation</bold></para>
<para>Following code snippet demonstrates blocking flash write. It uses a constant array with a size equaling the size of one flash row. This array is placed at an address in flash such that it occupies one complete flash row. It uses blocking flash write operation which blocks the caller until the write is completed. It then verifies the flash data by comparing the flash data with the written data. <programlisting filename="flash.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />cyhal_flash_get_info()<sp />to<sp />obtain<sp />values<sp />for<sp />the<sp />particular<sp />device<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_START_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x10000000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x100000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_PAGE_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(512)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />LAST_FLASH_ROW<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((FLASH_SIZE/FLASH_PAGE_SIZE)<sp />-<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />array<sp />reserves<sp />space<sp />in<sp />the<sp />flash<sp />for<sp />one<sp />page<sp />of<sp />size</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />FLASH_PAGE_SIZE.<sp />Explicit<sp />initialization<sp />is<sp />required<sp />so<sp />that<sp />memory<sp />is</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />allocated<sp />in<sp />flash<sp />instead<sp />of<sp />RAM.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CALCULATE_FLASH_ADDRESS(row_num)<sp />(FLASH_START_ADDR<sp />+<sp />((row_num)<sp />*<sp />FLASH_PAGE_SIZE))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Make<sp />the<sp />address<sp />point<sp />to<sp />last<sp />user<sp />flash<sp />page<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*flash_data_ptr<sp />=<sp />(uint8_t<sp />*)CALCULATE_FLASH_ADDRESS(LAST_FLASH_ROW);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flash<sp />Write<sp />Status<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />ram_data[FLASH_PAGE_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />RAM<sp />data<sp />to<sp />be<sp />written<sp />to<sp />Flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />flash_read_data[FLASH_PAGE_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />RAM<sp />data<sp />read<sp />from<sp />Flash<sp />for<sp />validation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />compare_status<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Compare<sp />Status<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flash<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref><sp />flash_obj;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />flash<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__flash_1ga669e3789204d0cf9610a85f26a28c55b">cyhal_flash_init</ref>(&amp;flash_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />data<sp />in<sp />RAM<sp />that<sp />will<sp />be<sp />written<sp />into<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />index<sp />=<sp />0;<sp />index<sp />&lt;<sp />FLASH_PAGE_SIZE;<sp />index++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ram_data[index]<sp />=<sp />(uint8_t)index;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Blocking<sp />flash<sp />erase<sp />prior<sp />to<sp />flash<sp />write<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1ga10b68f24a5c9a7c929a2c1fa3af89858">cyhal_flash_erase</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(result<sp />!=<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Error<sp />erasing<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Blocking<sp />flash<sp />write<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1ga622b0c7a66fb46946eedea821b5e12aa">cyhal_flash_write</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr,<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />*)ram_data);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />flash<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1gab21b7e9300c5b630e9656f71decedaf8">cyhal_flash_read</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr,<sp />flash_read_data,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(flash_read_data));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Verify<sp />the<sp />data<sp />written<sp />into<sp />flash<sp />by<sp />comparing<sp />it<sp />with<sp />the<sp />RAM<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0<sp />==<sp />memcmp(ram_data,<sp />flash_read_data,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(flash_read_data)))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />compare_status<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;It is recommended to declare the flash array as global variable.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Snippet 3: Non-blocking Flash Write Operation using polling</bold></para>
<para>Following code snippet implements the non-blocking flash write using polling to complete the flash write operation. It uses a constant array with a size equaling the size of one flash row. This array is placed at an address in flash such that it occupies one complete flash row. It uses a polling method to complete the flash write operation. It then verifies the flash data by comparing the flash data with the written data. <programlisting filename="flash.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />cyhal_flash_get_info()<sp />to<sp />obtain<sp />values<sp />for<sp />the<sp />particular<sp />device<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_START_ADDR<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x10000000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(0x100000)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />FLASH_PAGE_SIZE<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(512)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />LAST_FLASH_ROW<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />((FLASH_SIZE/FLASH_PAGE_SIZE)<sp />-<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />This<sp />array<sp />reserves<sp />space<sp />in<sp />the<sp />flash<sp />for<sp />one<sp />page<sp />of<sp />size</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />FLASH_PAGE_SIZE.<sp />Explicit<sp />initialization<sp />is<sp />required<sp />so<sp />that<sp />memory<sp />is</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />allocated<sp />in<sp />flash<sp />instead<sp />of<sp />RAM.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />CALCULATE_FLASH_ADDRESS(row_num)<sp />(FLASH_START_ADDR<sp />+<sp />((row_num)<sp />*<sp />FLASH_PAGE_SIZE))</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Make<sp />the<sp />address<sp />point<sp />to<sp />last<sp />user<sp />flash<sp />page<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*flash_data_ptr<sp />=<sp />(uint8_t<sp />*)CALCULATE_FLASH_ADDRESS(LAST_FLASH_ROW);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flash<sp />Write<sp />Status<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />ram_data[FLASH_PAGE_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />RAM<sp />data<sp />to<sp />be<sp />written<sp />to<sp />Flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />flash_read_data[FLASH_PAGE_SIZE];<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />RAM<sp />data<sp />read<sp />from<sp />Flash<sp />for<sp />validation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />compare_status<sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Compare<sp />Status<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flash<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__flash__t">cyhal_flash_t</ref><sp />flash_obj;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />flash<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__flash_1ga669e3789204d0cf9610a85f26a28c55b">cyhal_flash_init</ref>(&amp;flash_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />data<sp />in<sp />RAM<sp />that<sp />will<sp />be<sp />written<sp />into<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />index<sp />=<sp />0;<sp />index<sp />&lt;<sp />FLASH_PAGE_SIZE;<sp />index++)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ram_data[index]<sp />=<sp />(uint8_t)index;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />100ms<sp />for<sp />the<sp />flash<sp />write<sp />to<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />timeout<sp />=<sp />100;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Partially<sp />blocking<sp />flash<sp />erase<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1ga90697ece402e7e5f02303dbe568d0ba3">cyhal_flash_start_erase</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(</highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />!=<sp /><ref kindref="member" refid="group__group__hal__flash_1gad3f9a6b2b2af077d862c98bb7aa624ac">cyhal_flash_is_operation_complete</ref>(&amp;flash_obj))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />the<sp />flash<sp />erase<sp />to<sp />be<sp />successful<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Partially-blocking<sp />flash<sp />write<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1ga7de934ab80e8fcb82554735c98da3665">cyhal_flash_start_write</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr,<sp />(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />*)ram_data);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />100ms<sp />for<sp />the<sp />flash<sp />write<sp />to<sp />complete<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />timeout<sp />=<sp />100;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />for<sp />the<sp />successful<sp />flash<sp />write<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">((</highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />!=<sp /><ref kindref="member" refid="group__group__hal__flash_1gad3f9a6b2b2af077d862c98bb7aa624ac">cyhal_flash_is_operation_complete</ref>(&amp;flash_obj))<sp />&amp;&amp;<sp />(0<sp />&lt;<sp />timeout))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />timeout--;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga5f450769c1207d98134a9ced39adfdda">cyhal_system_delay_ms</ref>(1);<sp /></highlight><highlight class="comment">/*<sp />delay<sp />one<sp />millisecond<sp />each<sp />iteration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flag<sp />error<sp />if<sp />the<sp />expected<sp />flash<sp />write<sp />status<sp />not<sp />returned<sp />within<sp />timeout<sp />period<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0<sp />!=<sp />timeout)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />flash<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__flash_1gab21b7e9300c5b630e9656f71decedaf8">cyhal_flash_read</ref>(&amp;flash_obj,<sp />(uint32_t)flash_data_ptr,<sp />flash_read_data,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(flash_read_data));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Verify<sp />the<sp />data<sp />written<sp />into<sp />flash<sp />by<sp />comparing<sp />it<sp />with<sp />the<sp />RAM<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0<sp />==<sp />memcmp(ram_data,<sp />flash_read_data,<sp /></highlight><highlight class="keyword">sizeof</highlight><highlight class="normal">(flash_read_data)))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />compare_status<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
</programlisting><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;It is recommended to declare the flash array as global variable. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

    </detaileddescription>
  </compounddef>
</doxygen>